<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>Select a crop to proceed with the fertilization plan.</translate>
          </q-banner>

          <q-card-section>
            <q-select
              v-model="storePlantSpecies"
              :label="$gettext('Crop')"
              :options="plantSpeciesOptions"
              option-value="id"
              option-label="nameI18n"
              filled
              @filter="filterPlantSpecies"
              use-input
              input-debounce="200"
              :loading="$apollo.queries.plantSpecies.loading"
              @update:model-value="onPlantSpeciesChange"
              class="q-mt-md"
            />

            <div
              v-if="loading"
              class="column flex-center q-mt-md"
            >
              <q-spinner-dots
                color="primary"
                size="24px"
              />
            </div>
            <q-list
              v-else-if="cropProfileOptions && cropProfileOptions.length > 1"
              class="q-mt-md"
            >
              <q-item
                v-for="cropProfileOption in cropProfileOptions"
                :key="cropProfileOption.id"
                tag="label"
                v-ripple
                dense
                class="q-px-none"
              >
                <q-item-section avatar>
                  <q-radio
                    :val="cropProfileOption.id"
                    :model-value="storeCropProfile ? storeCropProfile.id : null"
                    @update:model-value="onCropProfileModelValueChange"
                  />
                </q-item-section>
                <q-item-section>
                  <q-item-label>{{ cropProfileOption[getRequafertiI18NFieldName('libelle')] }} </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
            <q-banner
              v-if="showCropProfileUnavailableBanner"
              class="bg-accent text-white q-mt-sm"
            >
              <translate>The crop %{storePlantSpecies.name} is not currently covered by %{algorithmName}.</translate>
            </q-banner>

            <q-select
              v-if="hasVegetationStageOptions"
              v-model="storeCropVegetationStage"
              :options="vegetationStageOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="loading"
              :label="$gettext('Vegetation stage')"
              class="q-mt-md"
            />

            <q-select
              v-if="hasSpinachHeightOptions"
              v-model="storeCropSpinachHeight"
              :options="spinachHeightOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="loading"
              :label="$gettext('Spinach height')"
              class="q-mt-md"
            />

            <q-select
              v-if="hasColzaCoverageOptions"
              v-model="storeCropColzaCoverage"
              :options="colzaCoverageOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="loading"
              :label="$gettext('Colza coverage')"
              class="q-mt-md"
            />

            <q-input
              v-if="hasCustomColzaCoverage"
              v-model.number="storeCropColzaCoverageCustom"
              filled
              type="number"
              :label="$gettext('N absorbed during winter')"
              :suffix="$gettext('kg N/ha')"
              :rules="[val => val > 0 || $gettext('This field must be positive')]"
              :min="0"
              step="0.1"
              hide-bottom-space
              :loading="loading"
              class="q-mt-md"
            />

            <q-input
              v-if="storeCropProfile && selectedCropYieldUnit"
              v-model.number="storeCropTargetYield"
              filled
              type="number"
              :label="$gettext('Target yield')"
              :suffix="selectedCropYieldUnit"
              :rules="[val => val > 0 || $gettext('This field must be positive')]"
              :min="0"
              step="0.1"
              hide-bottom-space
              :loading="loading"
              class="q-mt-md"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import queryPlantSpecies from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/queryPlantSpecies'
import queryRequafertiConfig from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiConfig'
import queryRequafertiAgriculturalRegion from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiAgriculturalRegion'
import { getI18nField } from 'src/services/translate'

export default {
  name: 'RequafertiCropProfilePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, RequafertiI18nMixin],
  data () {
    return {
      requafertiConfig: null,
      plantSpecies: [],
      filterValue: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Crop selection')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    canContinue () {
      return this.isParameterSet(this.storeCropProfile) &&
      (!this.hasVegetationStageOptions || this.isParameterSet(this.storeCropVegetationStage)) &&
      (!this.hasSpinachHeightOptions || this.isParameterSet(this.storeCropSpinachHeight)) &&
      (!this.hasColzaCoverageOptions || this.isParameterSet(this.storeCropColzaCoverage)) &&
      (!this.hasCustomColzaCoverage || this.isParameterSet(this.storeCropColzaCoverageCustom)) &&
      (!this.selectedCropYieldUnit || this.isParameterSet(this.storeCropTargetYield))
    },
    loading () {
      return (!this.plantSpecies && this.$apollo.queries.plantSpecies.loading) || !this.requafertiConfig
    },
    plotPlantSpecies () {
      return this.$store.state.fertilizationPlan.target.plot_plant_variety?.plant_variety?.plant_species
    },
    plotCropYield () {
      return this.$store.state.fertilizationPlan.target.plot_plant_variety?.crop_yield
    },
    requafertiCropMapping () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['type_cult_rqs_spw'] || []
    },
    matchingCropProfiles () {
      if (!this.requafertiCropMapping || !this.storePlantSpecies) {
        return []
      } else {
        return this.requafertiCropMapping
          .filter(row => row.cult_code_spw === this.storePlantSpecies.id)
          .map(row => this.cropOptions.find(crop => crop.id === row.id_cult_rqs))
          .filter(row => Boolean(row))
      }
    },
    plantSpeciesOptions () {
      let options = this.plantSpecies
      if (this.filterValue) {
        options = options.filter(v => v.name?.toLowerCase().indexOf(this.filterValue) > -1)
      }
      return options.map(plantSpecies => ({
        ...plantSpecies,
        nameI18n: getI18nField(plantSpecies, 'name')
      }))
    },
    cropOptions () {
      return this.requafertiConfig?.['type_cult']?.filter(cult => this.cropNitrogenRequirements.find(r => r.type_cult_xid === cult.id)) || []
    },
    sortedCropOptions () {
      const libelleI18n = this.getRequafertiI18NFieldName('libelle')
      return [...this.cropOptions].sort((a, b) => a[libelleI18n].localeCompare(b[libelleI18n]))
    },
    cropProfileOptions () {
      if (!this.requafertiCropMapping || !this.storePlantSpecies?.id) {
        return []
      } else {
        return this.matchingCropProfiles
      }
    },
    preSelectedCropProfile () {
      if (!this.storeCropProfile) {
        // pre-select the first crop matching the plant species
        return this.matchingCropProfiles?.[0]
      }
      return null
    },
    showCropProfileUnavailableBanner () {
      return !this.loading && this.storePlantSpecies && !this.storeCropProfile && !this.preSelectedCropProfile
    },
    vegetationStageOptions () {
      if (this.storeCropProfile?.id && this.requafertiConfig?.['culture_stade_vegetation']?.find(cult => cult.id === this.storeCropProfile.id)) {
        return this.requafertiConfig?.['stade_vegetation']
      } else {
        return []
      }
    },
    hasVegetationStageOptions () {
      return this.vegetationStageOptions?.length > 0
    },
    spinachHeightOptions () {
      if (this.storeCropProfile?.id && this.requafertiConfig?.['culture_epinard']?.find(cult => cult.id === this.storeCropProfile.id)) {
        return this.requafertiConfig?.['hauteur_epinard']
      } else {
        return []
      }
    },
    hasSpinachHeightOptions () {
      return this.spinachHeightOptions?.length > 0
    },
    colzaCoverageOptions () {
      if (this.storeCropProfile?.id && this.requafertiConfig?.['culture_colza']?.find(cult => cult.id === this.storeCropProfile.id)) {
        const coverageOptions = this.requafertiConfig?.['recouvrement_colza']
        if (coverageOptions.length > 0) {
          return [...coverageOptions, {
            id: 'custom',
            libelle: this.$gettext('Custom value')
          }]
        }
      }
      return []
    },
    hasColzaCoverageOptions () {
      return this.colzaCoverageOptions?.length > 0
    },
    hasCustomColzaCoverage () {
      return this.storeCropColzaCoverage?.id === 'custom'
    },
    cropNitrogenRequirements () {
      return this.requafertiConfig?.['besoin_n'] || []
    },
    selectedCropNitrogenRequirement () {
      if (this.storeAgriculturalRegion && this.storeCropProfile?.id) {
        return this.cropNitrogenRequirements.find(req => req.agr_libelle === this.storeAgriculturalRegion && req.type_cult_xid === this.storeCropProfile.id)
      }
      return null
    },
    selectedCropRecommendedYield () {
      const rendement = this.selectedCropNitrogenRequirement?.rendement
      return rendement != null ? Number(rendement) : null
    },
    selectedCropYieldUnit () {
      return this.selectedCropNitrogenRequirement?.[this.getRequafertiI18NFieldName('libelle_unite')]
    },
    plotCenterGeometry () {
      const coordinates = this.$store.state.fertilizationPlan.target.centroid?.coordinates
      return { type: 'Point', coordinates }
    },
    algorithmName () {
      return 'REQUAFERTI'
    },
    storePlantSpecies: {
      get () {
        if (this.$store.state.fertilizationPlan.parameters.plantSpecies) {
          return {
            ...this.$store.state.fertilizationPlan.parameters.plantSpecies,
            nameI18n: getI18nField(this.$store.state.fertilizationPlan.parameters.plantSpecies, 'name')
          }
        } else {
          return this.$store.state.fertilizationPlan.parameters.plantSpecies
        }
      },
      set (v) {
        this.updateParameter('plantSpecies', v)
      }
    },
    storeCropProfile: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropProfile
      },
      set (v) {
        this.updateParameter('cropProfile', v)
      }
    },
    storeCropVegetationStage: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropVegetationStage
      },
      set (v) {
        this.updateParameter('cropVegetationStage', v)
      }
    },
    storeCropSpinachHeight: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropSpinachHeight
      },
      set (v) {
        this.updateParameter('cropSpinachHeight', v)
      }
    },
    storeCropColzaCoverage: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropColzaCoverage
      },
      set (v) {
        this.updateParameter('cropColzaCoverage', v)
      }
    },
    storeCropColzaCoverageCustom: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropColzaCoverageCustom
      },
      set (v) {
        this.updateParameter('cropColzaCoverageCustom', v)
      }
    },
    storeCropTargetYield: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropTargetYield
      },
      set (v) {
        this.updateParameter('cropTargetYield', v)
      }
    },
    storeCropTargetYieldUnit: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropTargetYieldUnit
      },
      set (v) {
        this.updateParameter('cropTargetYieldUnit', v)
      }
    },
    storeAgriculturalRegion: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.agriculturalRegion
      },
      set (v) {
        this.updateParameter('agriculturalRegion', v)
      }
    }
  },
  apollo: {
    plantSpecies: {
      query: queryPlantSpecies,
      notifyOnNetworkStatusChange: true,
      update: data => data.plant_species
    }
  },
  async mounted () {
    if (!this.isParameterSet(this.storePlantSpecies) && this.plotPlantSpecies) {
      this.storePlantSpecies = { ...this.plotPlantSpecies }
    }

    // Load data from cache (or online if not in cache)
    await this.loadData('cache-first')

    // Preselect crop profile if there is only one choice available
    if (!this.isParameterSet(this.storeCropProfile) && this.matchingCropProfiles.length === 1) {
      this.storeCropProfile = this.preSelectedCropProfile
    }
    // Prefill yield if available
    if (!this.storeCropTargetYield && this.selectedCropRecommendedYield) {
      this.storeCropTargetYield = this.selectedCropRecommendedYield
    }
    this.storeCropTargetYieldUnit = this.selectedCropYieldUnit

    // Refresh online data (do not wait until completion)
    this.loadData('network-only')
  },
  methods: {
    onClickNext () {
      // reset unused fields
      if (!this.selectedCropYieldUnit) {
        this.storeCropTargetYield = null
      }
      if (!this.hasVegetationStageOptions) {
        this.storeCropVegetationStage = null
      }
      if (!this.hasSpinachHeightOptions) {
        this.storeCropSpinachHeight = null
      }
      if (!this.hasColzaCoverageOptions) {
        this.storeCropColzaCoverage = null
      }
      if (!this.hasCustomColzaCoverage) {
        this.storeCropColzaCoverageCustom = null
      }
      this.$router.push({ name: 'requafertiSoil' })
    },
    onClickPrevious () {
      const isEdition = this.$store.state.fertilizationPlan.isEdition
      const isCreationFromPlot = this.$store.state.fertilizationPlan.isCreationFromPlot
      if (isEdition) {
        const fertilizationPlanId = this.$store.state.fertilizationPlan.fertilizationPlanIdAndName.id
        this.$router.replace({ name: 'fertilizationPlan', params: { fertilizationPlanId } })
      } else if (isCreationFromPlot) {
        const plotId = this.$store.state.fertilizationPlan.target.id
        this.$router.replace({ name: 'plot', params: { idPlot: plotId } })
      } else {
        this.$router.replace({ name: 'fertilizationPlanPlotSelection' })
      }
    },
    filterPlantSpecies (val, update, abort) {
      update(() => {
        this.filterValue = val.toLowerCase()
      })
    },
    onPlantSpeciesChange () {
      this.storeCropProfile = null
      if (this.matchingCropProfiles.length === 1) {
        this.storeCropProfile = this.preSelectedCropProfile
      }
      this.onCropProfileChange()
    },
    onCropProfileChange () {
      // reset fields depending on selected crop when it changes
      this.storeCropTargetYield = this.selectedCropRecommendedYield ?? null
      this.storeCropVegetationStage = null
      this.storeCropSpinachHeight = null
      this.storeCropColzaCoverage = null
      this.storeCropColzaCoverageCustom = null
    },
    onCropProfileModelValueChange (value) {
      this.storeCropProfile = this.cropProfileOptions.find(crop => crop.id === value)
      this.onCropProfileChange()
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryRequafertiConfig,
        fetchPolicy
      })
      this.requafertiConfig = data?.requaferti__config
    },
    async getAgriculturalRegion (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryRequafertiAgriculturalRegion,
        variables: {
          geometry: this.plotCenterGeometry
        },
        fetchPolicy
      })
      this.storeAgriculturalRegion = data?.requaferti__agricultural_region
    },
    loadData (fetchPolicy) {
      return Promise.all([
        this.loadConfig(fetchPolicy),
        this.getAgriculturalRegion(fetchPolicy)
      ])
    }
  }
}
</script>
